]> git.ipfire.org Git - people/ms/u-boot.git/blob - MAKEALL
MAKEALL: Add spear platform target to compile all SPEAr boards
[people/ms/u-boot.git] / MAKEALL
1 #!/bin/bash
2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
4 # errors.
5
6 usage()
7 {
8 # if exiting with 0, write to stdout, else write to stderr
9 local ret=${1:-0}
10 [ "${ret}" -eq 1 ] && exec 1>&2
11 cat <<-EOF
12 Usage: MAKEALL [options] [--] [boards-to-build]
13
14 Options:
15 -a ARCH, --arch ARCH Build all boards with arch ARCH
16 -c CPU, --cpu CPU Build all boards with cpu CPU
17 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
18 -s SOC, --soc SOC Build all boards with soc SOC
19 -l, --list List all targets to be built
20 -m, --maintainers List all targets and maintainer email
21 -M, --mails List all targets and all affilated emails
22 -C, --check Enable build checking
23 -h, --help This help output
24
25 Selections by these options are logically ANDed; if the same option
26 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
27 will select all configurations where the vendor is either FOO or
28 BAR. Any additional arguments specified on the command line are
29 always build additionally. See the boards.cfg file for more info.
30
31 If no boards are specified, then the default is "powerpc".
32
33 Environment variables:
34 BUILD_NCPUS number of parallel make jobs (default: auto)
35 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
36 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
37 BUILD_DIR output build directory (default: ./)
38 BUILD_NBUILDS number of parallel targets (default: 1)
39
40 Examples:
41 - build all Power Architecture boards:
42 MAKEALL -a powerpc
43 MAKEALL --arch powerpc
44 MAKEALL powerpc
45 - build all PowerPC boards manufactured by vendor "esd":
46 MAKEALL -a powerpc -v esd
47 - build all PowerPC boards manufactured either by "keymile" or "siemens":
48 MAKEALL -a powerpc -v keymile -v siemens
49 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
50 MAKEALL -c mpc83xx -v freescale 4xx
51 EOF
52 exit ${ret}
53 }
54
55 SHORT_OPTS="ha:c:v:s:lmMC"
56 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,list,maintainers,mails,check"
57
58 # Option processing based on util-linux-2.13/getopt-parse.bash
59
60 # Note that we use `"$@"' to let each command-line parameter expand to a
61 # separate word. The quotes around `$@' are essential!
62 # We need TEMP as the `eval set --' would nuke the return value of
63 # getopt.
64 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
65 -n 'MAKEALL' -- "$@"`
66
67 [ $? != 0 ] && usage 1
68
69 # Note the quotes around `$TEMP': they are essential!
70 eval set -- "$TEMP"
71
72 SELECTED=''
73 ONLY_LIST=''
74 PRINT_MAINTS=''
75 MAINTAINERS_ONLY=''
76
77 while true ; do
78 case "$1" in
79 -a|--arch)
80 # echo "Option ARCH: argument \`$2'"
81 if [ "$opt_a" ] ; then
82 opt_a="${opt_a%)} || \$2 == \"$2\")"
83 else
84 opt_a="(\$2 == \"$2\")"
85 fi
86 SELECTED='y'
87 shift 2 ;;
88 -c|--cpu)
89 # echo "Option CPU: argument \`$2'"
90 if [ "$opt_c" ] ; then
91 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
92 else
93 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
94 fi
95 SELECTED='y'
96 shift 2 ;;
97 -s|--soc)
98 # echo "Option SoC: argument \`$2'"
99 if [ "$opt_s" ] ; then
100 opt_s="${opt_s%)} || \$6 == \"$2\")"
101 else
102 opt_s="(\$6 == \"$2\")"
103 fi
104 SELECTED='y'
105 shift 2 ;;
106 -v|--vendor)
107 # echo "Option VENDOR: argument \`$2'"
108 if [ "$opt_v" ] ; then
109 opt_v="${opt_v%)} || \$5 == \"$2\")"
110 else
111 opt_v="(\$5 == \"$2\")"
112 fi
113 SELECTED='y'
114 shift 2 ;;
115 -C|--check)
116 CHECK='C=1'
117 shift ;;
118 -l|--list)
119 ONLY_LIST='y'
120 shift ;;
121 -m|--maintainers)
122 ONLY_LIST='y'
123 PRINT_MAINTS='y'
124 MAINTAINERS_ONLY='y'
125 shift ;;
126 -M|--mails)
127 ONLY_LIST='y'
128 PRINT_MAINTS='y'
129 shift ;;
130 -h|--help)
131 usage ;;
132 --)
133 shift ; break ;;
134 *)
135 echo "Internal error!" >&2 ; exit 1 ;;
136 esac
137 done
138 # echo "Remaining arguments:"
139 # for arg do echo '--> '"\`$arg'" ; done
140
141 FILTER="\$1 !~ /^#/"
142 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
143 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
144 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
145 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
146
147 if [ "$SELECTED" ] ; then
148 SELECTED=$(awk '('"$FILTER"') { print $1 }' boards.cfg)
149
150 # Make sure some boards from boards.cfg are actually found
151 if [ -z "$SELECTED" ] ; then
152 echo "Error: No boards selected, invalid arguments"
153 exit 1
154 fi
155 fi
156
157 #########################################################################
158
159 # Print statistics when we exit
160 trap exit 1 2 3 15
161 trap print_stats 0
162
163 # Determine number of CPU cores if no default was set
164 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
165
166 if [ "$BUILD_NCPUS" -gt 1 ]
167 then
168 JOBS="-j $((BUILD_NCPUS + 1))"
169 else
170 JOBS=""
171 fi
172
173
174 if [ "${CROSS_COMPILE}" ] ; then
175 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
176 else
177 MAKE=make
178 fi
179
180 if [ "${MAKEALL_LOGDIR}" ] ; then
181 LOG_DIR=${MAKEALL_LOGDIR}
182 else
183 LOG_DIR="LOG"
184 fi
185
186 : ${BUILD_NBUILDS:=1}
187 BUILD_MANY=0
188
189 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
190 BUILD_MANY=1
191 : ${BUILD_DIR:=./build}
192 mkdir -p "${BUILD_DIR}/ERR"
193 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
194 fi
195
196 : ${BUILD_DIR:=.}
197
198 OUTPUT_PREFIX="${BUILD_DIR}"
199
200 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
201 find "${LOG_DIR}/" -type f -exec rm -f {} +
202
203 LIST=""
204
205 # Keep track of the number of builds and errors
206 ERR_CNT=0
207 ERR_LIST=""
208 WRN_CNT=0
209 WRN_LIST=""
210 TOTAL_CNT=0
211 CURRENT_CNT=0
212 OLDEST_IDX=1
213 RC=0
214
215 # Helper funcs for parsing boards.cfg
216 boards_by_field()
217 {
218 FS="[ \t]+"
219 [ -n "$3" ] && FS="$3"
220 awk \
221 -v field="$1" \
222 -v select="$2" \
223 -F "$FS" \
224 '($1 !~ /^#/ && $field == select) { print $1 }' \
225 boards.cfg
226 }
227 boards_by_arch() { boards_by_field 2 "$@" ; }
228 boards_by_cpu() { boards_by_field 3 "$@" "[: \t]+" ; }
229 boards_by_soc() { boards_by_field 6 "$@" ; }
230
231 #########################################################################
232 ## MPC5xx Systems
233 #########################################################################
234
235 LIST_5xx="$(boards_by_cpu mpc5xx)"
236
237 #########################################################################
238 ## MPC5xxx Systems
239 #########################################################################
240
241 LIST_5xxx="$(boards_by_cpu mpc5xxx)"
242
243 #########################################################################
244 ## MPC512x Systems
245 #########################################################################
246
247 LIST_512x="$(boards_by_cpu mpc512x)"
248
249 #########################################################################
250 ## MPC8xx Systems
251 #########################################################################
252
253 LIST_8xx="$(boards_by_cpu mpc8xx)"
254
255 #########################################################################
256 ## PPC4xx Systems
257 #########################################################################
258
259 LIST_4xx="$(boards_by_cpu ppc4xx)"
260
261 #########################################################################
262 ## MPC8220 Systems
263 #########################################################################
264
265 LIST_8220="$(boards_by_cpu mpc8220)"
266
267 #########################################################################
268 ## MPC824x Systems
269 #########################################################################
270
271 LIST_824x="$(boards_by_cpu mpc824x)"
272
273 #########################################################################
274 ## MPC8260 Systems (includes 8250, 8255 etc.)
275 #########################################################################
276
277 LIST_8260="$(boards_by_cpu mpc8260)"
278
279 #########################################################################
280 ## MPC83xx Systems (includes 8349, etc.)
281 #########################################################################
282
283 LIST_83xx="$(boards_by_cpu mpc83xx)"
284
285 #########################################################################
286 ## MPC85xx Systems (includes 8540, 8560 etc.)
287 #########################################################################
288
289 LIST_85xx="$(boards_by_cpu mpc85xx)"
290
291 #########################################################################
292 ## MPC86xx Systems
293 #########################################################################
294
295 LIST_86xx="$(boards_by_cpu mpc86xx)"
296
297 #########################################################################
298 ## 74xx/7xx Systems
299 #########################################################################
300
301 LIST_74xx_7xx="$(boards_by_cpu 74xx_7xx)"
302
303 #########################################################################
304 ## PowerPC groups
305 #########################################################################
306
307 LIST_TSEC=" \
308 ${LIST_83xx} \
309 ${LIST_85xx} \
310 ${LIST_86xx} \
311 "
312
313 LIST_powerpc=" \
314 ${LIST_5xx} \
315 ${LIST_512x} \
316 ${LIST_5xxx} \
317 ${LIST_8xx} \
318 ${LIST_8220} \
319 ${LIST_824x} \
320 ${LIST_8260} \
321 ${LIST_83xx} \
322 ${LIST_85xx} \
323 ${LIST_86xx} \
324 ${LIST_4xx} \
325 ${LIST_74xx_7xx}\
326 "
327
328 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
329 # still using "ppc" instead of "powerpc"
330 LIST_ppc=" \
331 ${LIST_powerpc} \
332 "
333
334 #########################################################################
335 ## StrongARM Systems
336 #########################################################################
337
338 LIST_SA="$(boards_by_cpu sa1100)"
339
340 #########################################################################
341 ## ARM7 Systems
342 #########################################################################
343
344 LIST_ARM7="$(boards_by_cpu arm720t)"
345
346 #########################################################################
347 ## ARM9 Systems
348 #########################################################################
349
350 LIST_ARM9="$(boards_by_cpu arm920t) \
351 $(boards_by_cpu arm926ejs) \
352 $(boards_by_cpu arm925t) \
353 $(boards_by_cpu arm946es) \
354 "
355
356 #########################################################################
357 ## ARM11 Systems
358 #########################################################################
359 LIST_ARM11="$(boards_by_cpu arm1136) \
360 $(boards_by_cpu arm1176) \
361 "
362
363 #########################################################################
364 ## ARMV7 Systems
365 #########################################################################
366
367 LIST_ARMV7="$(boards_by_cpu armv7)"
368
369 #########################################################################
370 ## AT91 Systems
371 #########################################################################
372
373 LIST_at91="$(boards_by_soc at91)"
374
375 #########################################################################
376 ## Xscale Systems
377 #########################################################################
378
379 LIST_pxa="$(boards_by_cpu pxa)"
380
381 LIST_ixp="$(boards_by_cpu ixp)"
382
383 #########################################################################
384 ## SPEAr Systems
385 #########################################################################
386
387 LIST_spear="$(boards_by_soc spear)"
388
389 #########################################################################
390 ## ARM groups
391 #########################################################################
392
393 LIST_arm="$(boards_by_arch arm)"
394
395 #########################################################################
396 ## MIPS Systems (default = big endian)
397 #########################################################################
398
399 LIST_mips4kc=" \
400 incaip \
401 incaip_100MHz \
402 incaip_133MHz \
403 incaip_150MHz \
404 qemu_mips \
405 vct_platinum \
406 vct_platinum_small \
407 vct_platinum_onenand \
408 vct_platinum_onenand_small \
409 vct_platinumavc \
410 vct_platinumavc_small \
411 vct_platinumavc_onenand \
412 vct_platinumavc_onenand_small \
413 vct_premium \
414 vct_premium_small \
415 vct_premium_onenand \
416 vct_premium_onenand_small \
417 "
418
419 LIST_au1xx0=" \
420 dbau1000 \
421 dbau1100 \
422 dbau1500 \
423 dbau1550 \
424 "
425
426 LIST_mips=" \
427 ${LIST_mips4kc} \
428 ${LIST_mips5kc} \
429 ${LIST_au1xx0} \
430 "
431
432 #########################################################################
433 ## MIPS Systems (little endian)
434 #########################################################################
435
436 LIST_xburst_el=" \
437 qi_lb60 \
438 "
439
440 LIST_au1xx0_el=" \
441 dbau1550_el \
442 pb1000 \
443 "
444 LIST_mips_el=" \
445 ${LIST_xburst_el} \
446 ${LIST_au1xx0_el} \
447 "
448 #########################################################################
449 ## OpenRISC Systems
450 #########################################################################
451
452 LIST_openrisc="$(boards_by_arch openrisc)"
453
454 #########################################################################
455 ## x86 Systems
456 #########################################################################
457
458 LIST_x86="$(boards_by_arch x86)"
459
460 #########################################################################
461 ## Nios-II Systems
462 #########################################################################
463
464 LIST_nios2="$(boards_by_arch nios2)"
465
466 #########################################################################
467 ## MicroBlaze Systems
468 #########################################################################
469
470 LIST_microblaze="$(boards_by_arch microblaze)"
471
472 #########################################################################
473 ## ColdFire Systems
474 #########################################################################
475
476 LIST_m68k="$(boards_by_arch m68k)"
477 LIST_coldfire=${LIST_m68k}
478
479 #########################################################################
480 ## AVR32 Systems
481 #########################################################################
482
483 LIST_avr32="$(boards_by_arch avr32)"
484
485 #########################################################################
486 ## Blackfin Systems
487 #########################################################################
488
489 LIST_blackfin="$(boards_by_arch blackfin)"
490
491 #########################################################################
492 ## SH Systems
493 #########################################################################
494
495 LIST_sh2="$(boards_by_cpu sh2)"
496 LIST_sh3="$(boards_by_cpu sh3)"
497 LIST_sh4="$(boards_by_cpu sh4)"
498
499 LIST_sh="$(boards_by_arch sh)"
500
501 #########################################################################
502 ## SPARC Systems
503 #########################################################################
504
505 LIST_sparc="$(boards_by_arch sparc)"
506
507 #########################################################################
508 ## NDS32 Systems
509 #########################################################################
510
511 LIST_nds32="$(boards_by_arch nds32)"
512
513 #-----------------------------------------------------------------------
514
515 get_target_location() {
516 local target=$1
517 local BOARD_NAME=""
518 local CONFIG_NAME=""
519 local board=""
520 local vendor=""
521
522 # Automatic mode
523 local line=`egrep -i "^[[:space:]]*${target}[[:space:]]" boards.cfg`
524
525 if [ -z "${line}" ] ; then echo "" ; return ; fi
526
527 set ${line}
528
529 # add default board name if needed
530 [ $# = 3 ] && set ${line} ${1}
531
532 CONFIG_NAME="${1%_config}"
533
534 [ "${BOARD_NAME}" ] || BOARD_NAME="${1%_config}"
535
536 if [ "$4" = "-" ] ; then
537 board=${BOARD_NAME}
538 else
539 board="$4"
540 fi
541
542 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
543 [ $# -gt 6 ] && [ "$7" != "-" ] && {
544 tmp="${7%:*}"
545 if [ "$tmp" ] ; then
546 CONFIG_NAME="$tmp"
547 fi
548 }
549
550 # Assign board directory to BOARDIR variable
551 if [ -z "${vendor}" ] ; then
552 BOARDDIR=${board}
553 else
554 BOARDDIR=${vendor}/${board}
555 fi
556
557 echo "${CONFIG_NAME}:${BOARDDIR}"
558 }
559
560 get_target_maintainers() {
561 local name=`echo $1 | cut -d : -f 1`
562
563 if ! grep -qsi "[[:blank:]]${name}[[:blank:]]" MAINTAINERS ; then
564 echo ""
565 return ;
566 fi
567
568 local line=`tac MAINTAINERS | grep -ni "[[:blank:]]${name}[[:blank:]]" | cut -d : -f 1`
569 local mail=`tac MAINTAINERS | tail -n +${line} | \
570 sed -n ":start /.*@.*/ { b mail } ; n ; b start ; :mail /.*@.*/ { p ; n ; b mail } ; q" | \
571 sed "s/^.*<//;s/>.*$//"`
572 echo "$mail"
573 }
574
575 list_target() {
576 if [ "$PRINT_MAINTS" != 'y' ] ; then
577 echo "$1"
578 return
579 fi
580
581 echo -n "$1:"
582
583 local loc=`get_target_location $1`
584
585 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
586
587 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
588
589 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
590
591 local dir=`echo ${loc} | cut -d ":" -f 2`
592 local cfg=`echo ${loc} | cut -d ":" -f 1`
593 local git_result=`git log --format=%aE board/${dir} \
594 include/configs/${cfg}.h | grep "@"`
595 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
596 head -n 3`
597 local git_result_top=`echo ${git_result} | tr " " "\n" | \
598 sort | uniq -c | sort -nr | head -n 3 | \
599 sed "s/^ \+[0-9]\+ \+//"`
600
601 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
602 sort -u | tr "\n" " " | sed "s/ $//" ;
603 else
604 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
605 sed "s/ $//" ;
606 fi
607
608 echo ""
609 }
610
611 # Each finished build will have a file called ${donep}${n},
612 # where n is the index of the build. Each build
613 # we've already noted as finished will have ${skipp}${n}.
614 # The code managing the build process will use this information
615 # to ensure that only BUILD_NBUILDS builds are in flight at once
616 donep="${LOG_DIR}/._done_"
617 skipp="${LOG_DIR}/._skip_"
618
619 build_target() {
620 target=$1
621 build_idx=$2
622
623 if [ "$ONLY_LIST" == 'y' ] ; then
624 list_target ${target}
625 return
626 fi
627
628 if [ $BUILD_MANY == 1 ] ; then
629 output_dir="${OUTPUT_PREFIX}/${target}"
630 mkdir -p "${output_dir}"
631 else
632 output_dir="${OUTPUT_PREFIX}"
633 fi
634
635 export BUILD_DIR="${output_dir}"
636
637 ${MAKE} distclean >/dev/null
638 ${MAKE} -s ${target}_config
639
640 ${MAKE} ${JOBS} ${CHECK} all \
641 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
642
643 # Check for 'make' errors
644 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
645 RC=1
646 fi
647
648 if [ $BUILD_MANY == 1 ] ; then
649 ${MAKE} -s tidy
650
651 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
652 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
653 else
654 rm ${LOG_DIR}/${target}.ERR
655 fi
656 else
657 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
658 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
659 : $(( ERR_CNT += 1 ))
660 ERR_LIST="${ERR_LIST} $target"
661 else
662 : $(( WRN_CNT += 1 ))
663 WRN_LIST="${WRN_LIST} $target"
664 fi
665 else
666 rm ${LOG_DIR}/${target}.ERR
667 fi
668 fi
669
670 OBJS=${output_dir}/u-boot
671 if [ -e ${output_dir}/spl/u-boot-spl ]; then
672 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
673 fi
674
675 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
676
677 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
678
679 touch "${donep}${build_idx}"
680 }
681
682 manage_builds() {
683 search_idx=${OLDEST_IDX}
684 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
685
686 while true; do
687 if [ -e "${donep}${search_idx}" ] ; then
688 : $(( CURRENT_CNT-- ))
689 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
690 : $(( OLDEST_IDX++ ))
691
692 # Only want to count it once
693 rm -f "${donep}${search_idx}"
694 touch "${skipp}${search_idx}"
695 elif [ -e "${skipp}${search_idx}" ] ; then
696 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
697 : $(( OLDEST_IDX++ ))
698 fi
699 : $(( search_idx++ ))
700 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
701 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
702 search_idx=${OLDEST_IDX}
703 sleep 1
704 else
705 break
706 fi
707 fi
708 done
709 }
710
711 build_targets() {
712 for t in "$@" ; do
713 # If a LIST_xxx var exists, use it. But avoid variable
714 # expansion in the eval when a board name contains certain
715 # characters that the shell interprets.
716 case ${t} in
717 *[-+=]*) list= ;;
718 *) list=$(eval echo '${LIST_'$t'}') ;;
719 esac
720 if [ -n "${list}" ] ; then
721 build_targets ${list}
722 else
723 : $((TOTAL_CNT += 1))
724 : $((CURRENT_CNT += 1))
725 rm -f "${donep}${TOTAL_CNT}"
726 rm -f "${skipp}${TOTAL_CNT}"
727 if [ $BUILD_MANY == 1 ] ; then
728 build_target ${t} ${TOTAL_CNT} &
729 else
730 build_target ${t} ${TOTAL_CNT}
731 fi
732 fi
733
734 # We maintain a running count of all the builds we have done.
735 # Each finished build will have a file called ${donep}${n},
736 # where n is the index of the build. Each build
737 # we've already noted as finished will have ${skipp}${n}.
738 # We track the current index via TOTAL_CNT, and the oldest
739 # index. When we exceed the maximum number of parallel builds,
740 # We look from oldest to current for builds that have completed,
741 # and update the current count and oldest index as appropriate.
742 # If we've gone through the entire list, wait a second, and
743 # reprocess the entire list until we find a build that has
744 # completed
745 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
746 manage_builds
747 fi
748 done
749 }
750
751 #-----------------------------------------------------------------------
752
753 kill_children() {
754 kill -- "-$1"
755
756 exit
757 }
758
759 print_stats() {
760 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
761
762 rm -f ${donep}* ${skipp}*
763
764 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
765 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
766 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
767 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
768 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
769 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
770 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
771 fi
772
773 echo ""
774 echo "--------------------- SUMMARY ----------------------------"
775 echo "Boards compiled: ${TOTAL_CNT}"
776 if [ ${ERR_CNT} -gt 0 ] ; then
777 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
778 fi
779 if [ ${WRN_CNT} -gt 0 ] ; then
780 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
781 fi
782 echo "----------------------------------------------------------"
783
784 if [ $BUILD_MANY == 1 ] ; then
785 kill_children $$ &
786 fi
787
788 exit $RC
789 }
790
791 #-----------------------------------------------------------------------
792
793 # Build target groups selected by options, plus any command line args
794 set -- ${SELECTED} "$@"
795 # run PowerPC by default
796 [ $# = 0 ] && set -- powerpc
797 build_targets "$@"
798 wait